from h5py import File
import numpy as np
from h5schemas.projection.add_projection import (
    init_projection_dataset,
    add_projection_sample,
)


def main():
    # Generate a file in write mode.
    test_file = File("./examples/projection.h5", "w")

    # Initialize the .H5 structure
    init_projection_dataset(test_file, False, (128, 128), (0.139, 0.139))

    # Add dummy projections
    add_projection_sample(
        test_file,
        1e5 * np.random.random((128, 128)),
        [0.0, 1.0, 2.0],
        [3.0, 4.0, 5.0, 6.0],
        [7.0, 8.0, 9.0],
        [10.0, 11.0, 12.0, 13],
    )
    add_projection_sample(
        test_file,
        1e5 * np.random.random((128, 128)),
        np.array([0.0, 1.0, 2.0]),
        np.array([3.0, 4.0, 5.0, 6.0]),
        np.array([7.0, 8.0, 9.0]),
        np.array([10.0, 11.0, 12.0, 13]),
        voltage_kv=100,
    )

    # Access data
    print(test_file["/image/image_array"][...])


if __name__ == "__main__":
    main()
